
/* AMX Mod script.
*
* This file is provided as is (no warranties).
*
*/ 

#include <amxmod>
#define ACCESS ADMIN_LEVEL_A

new gag[33] 

public check_gag(id){ 
	if(gag[id] != 0){ 
		new flags = gag[id] 
		new cmd[16+1] 
		read_argv(0,cmd,16) 
		if(containi(cmd,"_team") == -1) {
			if ((flags&1) || (flags&2)) { 
				client_print(id,print_notify,"[AMX] You are gagged")
				return PLUGIN_HANDLED
			}
		} else {
			if(flags&2) {
				client_print(id,print_notify,"[AMX] You are gagged")
				return PLUGIN_HANDLED 
			}
		}
	} 
	return PLUGIN_CONTINUE 
} 

public amx_gag(id) { 
	if(!(get_user_flags(id)&ACCESS) && id) { 
	client_print(id,print_console,"[AMX] Access Denied") 
	return PLUGIN_HANDLED 
	} 
	new argc = read_argc() 
	if (argc < 3) { 
	if(id) { 
		client_print(id,print_console,"[AMX] Usage: amx_gag <a | b | c> < name > < time >") 
		client_print(id,print_console,"[AMX] a = Normal Say") 
		client_print(id,print_console,"[AMX] b = Team Say") 
		client_print(id,print_console,"[AMX] c = Voice Comm") 
	} else if(id == 0) { 
		server_print("[AMX] Usage: amx_gag <a | b | c> < name > < time >") 
		server_print("[AMX] a = Normal Say") 
		server_print("[AMX] b = Team Say") 
		server_print("[AMX] c = Voice Comm") 
	} 
	return PLUGIN_HANDLED 
	} 
	new gag_time 
	new flagstr[12 + 1] 
	new pidstr[12 + 1] 
	new name[32 + 1] 
	read_argv(1,flagstr,12) 
	new flags = read_flags(flagstr) 
	read_argv(2,name,32) 
	new pid = find_player("bl",name) 
	get_user_name(id,name,32) 
	if (argc == 4) { 
	new gagt_str[12 + 1] 
	read_argv(3,gagt_str,12) 
	gag_time = str_to_num(gagt_str) 
	if(!gag_time) 
		gag_time = 9999 
	} else { 
	gag_time = 9999 
	} 
	if(flags&4) { 
	new players[32] 
	new pNum 
	get_players(players,pNum) 
	for (new i = 0;i<pNum;i++) 
		set_user_listening(players[i],pid,0) 
	} 
	gag[pid] = flags 
	format(pidstr,12,"%i",pid) 
	set_task(float(gag_time),"ungag",pid,pidstr,12) 
	return PLUGIN_HANDLED 
} 


public ungag(param[]) { 
	new id = str_to_num(param) 
	new flags = gag[id] 
	if(flags&4) { 
	new players[32] 
	new pNum 
	get_players(players,pNum) 
	for (new i = 0;i<pNum;i++) 
		set_user_listening(players[i],id,1) 
	} 
	gag[id] = 0 
	return PLUGIN_HANDLED 
} 

public amx_ungag(id) { 
	if(!(get_user_flags(id)&ACCESS) && id) { 
		client_print(id,print_console,"[AMX] Access Denied") 
		return PLUGIN_HANDLED 
	} 
	new argc = read_argc() 
	if (argc < 2) {
		if(id) { 
			client_print(id,print_console,"[AMX] Usage: amx_ungag < name >") 
		} else if(id == 0) { 
			server_print("[AMX] Usage: amx_ungag < name >") 
		} 
		return PLUGIN_HANDLED 
	}
	new name[32 + 1] 
	read_argv(1,name,32) 
	new pid = find_player("lb",name) 
	new pidstr[12 + 1]
	remove_task(pid) 
	format(pidstr,12,"%i",pid) 
	ungag(pidstr) 
	return PLUGIN_HANDLED 
} 

public client_disconnect(id) {
	gag[id] = 0
	remove_task(id)
	return PLUGIN_CONTINUE
}

public plugin_init() { 
	for (new i = 0;i<33;i++) 
	gag[i] = 0 
	register_plugin("Admin gag","0.6","default") 
	register_clcmd("say","check_gag") 
	register_clcmd("say_team","check_gag") 
	register_clcmd("amx_gag","amx_gag",ACCESS,"amx_gag <a | b | c> < name > < time >") 
	register_clcmd("amx_ungag","amx_ungag",ACCESS,"amx_ungag < name >") 
	register_srvcmd("amx_gag","amx_gag") 
	register_srvcmd("amx_ungag","amx_ungag") 
	return PLUGIN_CONTINUE 
}  

